#ifndef __SDK_GETSTATICINFO_H
#define __SDK_GETSTATICINFO_H

#ifdef __cplusplus
extern "C"
{
#endif

#define NVME_BLOCK 100
#define SATA_BLOCK 101
#define UNCHECKED_BLOCK 102
#define SYSUUIDCMD "dmidecode -s system-uuid"
#define SERIALNUMBER "dmidecode -s system-serial-number"
#define OS_RELEASE "cat /etc/os-release | grep VERSION_ID"
#define MAIN_BLOCK_DEV "cat /etc/mtab | grep \"\\ \\/\\ \" | gawk '{print $1}'"
// #define HDSN_SATA "smartctl -i /dev/sda | grep \"Serial Number:\" | awk '{print $3}'"
// #define HDSN_NVME "smartctl -i /dev/nvme0n1 | grep \"Serial Number:\" | awk '{print $3}'"
#define HDSN_SATA "find /sys/devices/ -type f| grep -v virtual | xargs grep 'DEVTYPE=disk' 2>/dev/null | awk -F'/uevent' '{print $1}'| xargs -I {} echo {}/../../ 2>/dev/null | xargs -I {} find {} -type f | grep 'wwid\\|serial' |xargs cat 2>/dev/null| awk -F' ' '{print $NF}' | head -n1"
#define HDSN_NVME "find /sys/devices/ -type f| grep -v virtual | xargs grep 'DEVTYPE=disk' 2>/dev/null | awk -F'/uevent' '{print $1}'| xargs -I {} echo {}/../../ 2>/dev/null | xargs -I {} find {} -type f | grep 'wwid\\|serial' |xargs cat 2>/dev/null| awk -F' ' '{print $NF}' | head -n1"
#define BUILDTIME "/usr/share/NFS Desktop/buildtime"
#define RELEASE_TYPE "cat /etc/os-release | grep RELEASE_TYPE"
#define LENOVO_STRING "OEM-LENOVO"
#define INESA_STRING "OEM-INESA"

#define HTTP_SERVER "http://nisc.nfschina.com/v1/regauth/"
//#define HTTP_SERVER "http://172.30.18.135/v1/regauth/"
#define DEBUG_SERVER "http://192.168.8.132:8000/v1/regauth/"
#define LOCAL_SERVER "http://192.168.8.125:8000/push/"
#define BASE_VERSION "SDK v1.0"
#define FILENAME "callback.log"
#define DEVNAME "/dev/sda"

typedef struct{
	char SC_RespInfo[64];
	char SC_ValidTime[20];
	long int SC_RespCode;
}sc_statuscode_t;

enum{
	HTTP_RESPONSE_CODE_200 = 200,
	HTTP_RESPONSE_CODE_201,

	HTTP_RESPONSE_CODE_302 = 302,
	HTTP_RESPONSE_CODE_303,

	HTTP_RESPONSE_CODE_400 = 400,
	HTTP_RESPONSE_CODE_404 = 404,
	HTTP_RESPONSE_CODE_405,
	HTTP_RESPONSE_CODE_406,
	HTTP_RESPONSE_CODE_410 = 410,
};

typedef enum{
    SUCCESS = 0,

    ERROR_POPEN = 100,
    ERROR_MAKEPOSTFILEDS,
    ERROR_GET_SYSINFO,
    ERROR_GET_OSRELEASE,
    ERROR_GET_BUILDTIME,
    ERROR_GET_HDSN,
    ERROR_GET_SERNUM,
    ERROR_MD5_ENCRYPT,
    ERROR_JSON_STRING,
    ERROR_JSON_PARESEDATA,
    ERROR_SDK_MD5ENCRYPT,

    ERROR_CURL_GET = 200,
    ERROR_CURL_POST,
    ERROR_CURL_PREFORM
}SDK_ErrCode_t;

/*
   函数 : _SDK_TestAdd
*/
SDK_ErrCode_t _SDK_TestAdd(int a, int b);

size_t _CURL_WriteCallback(void *buffer, size_t size, size_t nmemb, void *user_p);

static inline SDK_ErrCode_t _Comm_TransStr(char *str, char *res);
static inline char * _Comm_GetRightN(char *dst,char *src, int n);

/*
   函数名 : 	_JSON_ParseData
   参数 	:  	buff 待解析JSON	字符串
   				sc 结构体指针
   返回值 : 	成功返回0，失败返回错误原因代码
   功能	:  	解析JSON  数据，获取状态码
*/
SDK_ErrCode_t _JSON_ParseData(char *buff, sc_statuscode_t *sc);

inline SDK_ErrCode_t _SDK_MakePostFields(char *RegCode, char *RetStr);
inline int _SDK_GetHDSN_BAK(const char* szDevName, char* szSN, size_t nLimit);
inline int _SDK_GetMainBlockDev();
inline int _SDK_GetHDSN(char *os_hdsn);

inline int _SDK_GetOSRelease(char *os_rel);
inline int _SDK_GetReleaseType(char *rel_type);
inline int _SDK_GetBuildTime(char *bt);
inline int _SDK_GetSystemUUID(char *sysuuid);
inline int _SDK_GetSystemSerialNumber(char *syssn);
//int _SDK_DoRegister(char *RegCode, sc_statuscode_t *res);
SDK_ErrCode_t _SDK_GetHostInfo(char *RegCode, char *RetStr); //for reginfo auth without net
sc_statuscode_t * _SDK_DoRegisterForAuth(char *RegInfoStr); //for reginfo auth without net
sc_statuscode_t * _SDK_ConfirmRegForAuth(char *RegInfoStr); //for reginfo auth without net
sc_statuscode_t * _SDK_DoRegister(char *RegCode, char *OrgName, char *OrgContact);
sc_statuscode_t * _SDK_CheckRegister();
sc_statuscode_t * _SDK_ConfirmRegister(char *RegCode, char *OrgName, char *OrgContact);
sc_statuscode_t * _SDK_DoVerify();
SDK_ErrCode_t _SDK_GetRespCode(sc_statuscode_t * StatusCode);
SDK_ErrCode_t _SDK_MD5Encrypt(char *RetStr);

char* _SDK_AES_EnCrypto(char* in);
char* _SDK_AES_DeCrypto(char* in);
SDK_ErrCode_t _SKD_GetSafeID(char *RetStr);
char* _SDK_Encode(char* serialcode, char* safe_id);
char* _SDK_GetServerIP(char* addr, char* port);

/*
   函数名 : 	_SDK_GetLibVersion
   参数 	:  	无
   返回值 : 	成功返回0，失败返回错误原因代码
   功能	:  	获取SDK 版本信息
*/
SDK_ErrCode_t _SDK_GetLibVersion();

/*
   函数名 : 	_MD5_Encrypt
   参数 	: 	srcStr  待加密字符串
   				EncryptStr 加密后返回串
   返回值 :  	成功返回0，失败返回错误原因代码
   功能	:  	字符串MD5	加密
*/
SDK_ErrCode_t _MD5_Encrypt(char *srcStr, char *EncryptStr);


/*
   函数名 : 	_CURL_CommPost
   参数 	: 	EncryptStr 已构造的POST	请求参数字符串
   返回值 :  	成功返回0，失败返回错误原因代码
   功能	:  	利用CURL	进行POST	请求
*/
int _CURL_CommPost(char *EncryptStr);


/*
   函数名 : 	_CURL_CommGet
   参数 	: 	EncryptStr 已机密的GET   请求参数字符串
   				如:	    e4f5a986b785994266ebe3cae4b24141
   返回值 :  	成功返回0，失败返回错误原因代码
   功能	:  	利用CURL	进行GET	请求
*/
int _CURL_CommGet(char *EncryptStr);

#ifdef __cplusplus
}
#endif

#endif
